<template>
  <div>
    <div class="titulo">
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Infraestructura</strong>
    </div>
    <div class="contSecc">
      <div class="titSecCard">Listado de versiones</div>
      <v-data-table
        :headers="headers"
        :items="items"
        :loading="loading"
        :dense="true"
        :fixed-header="true"
        class="custom-table"
        hide-default-footer
      >
        <template v-slot:item.fecha="{ item }" }>
          {{ formatDate(item.fecha) }}</template
        >
        <template v-slot:item.verarchivo="{ item }">
          <div class="link" @click="redirecciona(item.uid, item.idFolio)">
            ver Archivo
          </div>
        </template>
        <template v-slot:item.descargar="{ item }">
          <div
            class="link"
            @click="
              descargar(item.uid, item.idFolio, item.nombre, item.extension)
            "
          >
            Descargar
          </div>
          <a id="dwnldLnk" download="nombre.pdf" style="display: none" />
        </template>
      </v-data-table>
    </div>
  </div>
</template>
<style scoped>
.publicado--text {
  color: #4fd495;
}
.revisar--text {
  color: #fdae31;
}
.autorizar--text {
  color: #feb94b;
}
.documentar--text {
  color: #fad743;
}
.link {
  text-decoration: underline;
  color: black;
  cursor: pointer;
}
.float-rigth.v-btn {
  float: right;
}
.float-left {
  float: left;
}
</style>
<style>
.theme--light.v-data-table.v-data-table--fixed-header thead {
  border-bottom: #ffcd00 3px solid;
}
.theme--light.v-data-table.v-data-table--fixed-header thead th {
  background-color: #fafafa;
}
div.custom-table div table tbody tr:nth-child(odd) {
  background-color: #fafafa;
}

div.custom-table div table tbody tr:nth-child(even) {
  background-color: #f0f0f0;
}

div.custom-table div table tbody tr:hover {
  background-color: #ffcd0059 !important;
}
div.custom-table .t-footer {
  background-color: #fafafa;
}
.v-data-table.custom-table.theme--light.v-data-table {
  background-color: #fafafa;
}
</style>
<script>
import router from "@/router";
import store from "@/store";
import moment from "moment";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "infraestructura_layouts_version_documentos",

  data: (vm) => ({
    idArchivo: null,
    headers: [
      { text: "Nombre", value: "nombre", align: "center" },
      { text: "Descripcion", value: "descripcion", align: "center" },
      { text: "Proyecto", value: "nombreProyecto", align: "center" },
      { text: "Documento", value: "nombreDocumento", align: "center" },
      { text: "Tipo de Archivo", value: "extension", align: "center" },
      { text: "Fecha", value: "fecha", align: "center" },
      { text: "Version", value: "indice", align: "center" },
      { text: "Ver Archivo", value: "verarchivo", align: "center" },
      { text: "Descargar", value: "descargar", align: "center" },
    ],
    items: [],
    breadcrumbs: [
      {
        text: "Plataforma de Franquicia",
        disabled: false,
        exact: true,
        to: {
          name: "home",
        },
      },
      {
        text: "Administracion Layouts",
        disabled: false,
        exact: true,
        to: {
          name: "infraestructura_layouts_administrador_layouts",
        },
      },
      {
        text: "Archivos",
        disabled: false,
        exact: true,
        to: {
          name: "infraestructura_layouts_documentos",
        },
      },
      {
        text: "Lista de versiones",
        disabled: true,
        exact: true,
      },
    ],
  }),
  methods: {
    formatDate(date) {
      return moment(date).format("DD-MM-YYYY");
    },
    obtenerParametros() {
      this.idArchivo = this.$route.params.idArchivo;
      console.log(this.idArchivo);
      if (this.idArchivo) {
        console.log(this.idArchivo);
        localStorage.idArchivo = parseInt(this.idArchivo);
      }
    },
    getListaArchivos() {
      var self = this;
      self.items = [];
      this.idArchivo = localStorage.idArchivo;
      axios(
        "/documento-sucursal/virtuales-archivos/v1/busquedas/versiones/archivo/" +
          this.idArchivo
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            self.items = data.resultado.folioVirtualesArchivos;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    redirecciona(uuid, folio) {
      router.push({
        name: "infraestructura_layouts_visualizador_pdf",
        params: {
          uuid: uuid,
          folio: folio,
        },
      });
    },
    descargar(uuid, folio, nombre, extencion) {
      const self = this;
      axios(
        "/documento-sucursal/archivos/v1/" +
          folio +
          "/archivos/" +
          uuid +
          "/contenido"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            let initialDoc = data.resultado.archivo;

            var dlnk = document.getElementById("dwnldLnk");

            dlnk.href = initialDoc;
            if (extencion == "dwg") {
              dlnk.download = nombre.split(".")[0] + +"." + extencion;
            } else {
              dlnk.download = nombre.split(".")[0] + +".pdf";
            }

            dlnk.click();
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
  },
  created() {
    var source = this.$route.params.source;
    var name_to = "";

    if (source == 332) {
      name_to = "infraestructura_layouts_documentos";
    } else if (source == 333) {
      name_to = "listado_de_documentos_infraestructura_proyectos_construccion";
    } else if (source == 334) {
      name_to = "infraestructura_layouts_documentos_geografia_negocio";
    } else if (source == 335) {
      name_to = "listado_de_documentos_infraestructura_certificacion";
    } else {
      name_to = "infraestructura_layouts_documentos";
    }

    this.breadcrumbs[2].to.name = name_to;
    this.obtenerParametros();
    this.getListaArchivos();
  },
};
</script>
